<?php
/**
 * Plugin Name: Email Tunnel
 * Plugin URI: https://email-tunnel.com/wp-content/uploads/email-tunnel.zip
 * Description: Tunnel emails from one site out of another site
 * Donate Link: https://generalchicken.guru
 * Author: GeneralChicken
 * Version: 3.2
 * Author URI: https://email-tunnel.com
 * Text Domain: email-tunnel
 * Licence: Copyright (C) 2023 email-tunnel.com All rights reserved - THIS IS NOT OPEN SOURCE OR FREE SOFTWARE!
 */


//phpinfo();

//die("email-tunnel");

require_once(plugin_dir_path(__FILE__) . 'src/EmailTunnel/autoloader.php');

global $EmailTunnelConstants;
$EmailTunnelConstants = new EmailTunnel\Constants;

global $showConnections;
$showConnections = false;

\add_action("init", function () {
    global $showConnections;
    if ($showConnections) {
        \ETM\DevETMConnectionCPT::register_ETMConnectionCPT();
    } else {
        \EmailTunnel\ETMConnectionCPT::register_ETMConnectionCPT();
    }
});
\EmailTunnel\DevMode::enableEmitDevSiteAddys();
$validatedRemoteNode = \EmailTunnel\ConnectionFinder::fetchValidatedNodeConnection();
$tunnelStatus = EmailTunnel\SiteStatus::getSiteStatus($validatedRemoteNode);
if ($tunnelStatus == "entrance") {
    if (!function_exists('wp_mail')) {
        require_once(plugin_dir_path(__FILE__) . 'src/EmailTunnel/wp_mail.func.php');
    }
}
if ($tunnelStatus == "exit") {
    \add_action('rest_api_init', [new EmailTunnel\TunnelExit, 'doOpenExitAPI']);
}
add_action('admin_menu', 'register_my_custom_submenu_page');
function register_my_custom_submenu_page()
{

    add_submenu_page('tools.php', 'Email Tunnel', 'Email Tunnel', 'manage_options', 'email-tunnel', function () {
        if (isset($_REQUEST['etm-activation-nonce'])) {
            $SettingsPage = new EmailTunnel\ActivationAttemptPage;
            $SettingsPage->render();
        } else {
            $SettingsPage = new EmailTunnel\SettingsPage;
            $SettingsPage->render();
        }
    });
}

if ((isset($_GET['page'])) and ($_GET['page'] === "email-tunnel")) {
    //This is the initial page load for the settings page. Subsequent polls of the StatusArray are done through the status array api
    \add_action("init", function () {
        if ((\EmailTunnel\ConnectionFinder::get_post_type_by_title("THIS IS A VALIDATED REMOTE NODE", "OBJECT", "etm-connection")) != null) {
            $statusData = (\EmailTunnel\SonarPing::doSonarPing());
            echo("
            <script>
            console.log('result from ping attempt (SonarPing.class.php #61):');
            let EmailTunnelTunnelStatusArray =  $statusData;
            console.log(EmailTunnelTunnelStatusArray);
            </script>
        ");
        }
    });
}

if (!(isset($_REQUEST['etm-activation-nonce']))) {
    add_action('admin_enqueue_scripts', 'enableAdminJS');
}

function enableAdminJS()
{
    global $pagenow;
    if (isset($_GET['page'])) {
        if (($pagenow == 'tools.php') && ($_GET['page'] == "email-tunnel")) {
           // add_filter( 'heartbeat_settings', 'wp_heartbeat_settings_3242' );
            wp_register_script(
                'email-tunnel-js',
                plugin_dir_url(__FILE__) . '/src/EmailTunnel/SettingsPage.js', // here is the JS file
                ['jquery', 'wp-api','heartbeat'],
                '1.0',
                true
            );
            $emailTunnelStatusData = [];

            $emailTunnelStatusData['status'] = EmailTunnel\SiteStatus::getSiteStatus(EmailTunnel\ConnectionFinder::fetchValidatedNodeConnection());
            // wp_localize_script( 'email-tunnel-js', 'EmailTunnelStatusData', $emailTunnelStatusData );
            wp_enqueue_script('email-tunnel-js');
        }
    }
}

add_action('rest_api_init', '\EmailTunnel\Connections::register_API_Routes');
add_action('rest_api_init', [new \EmailTunnel\Action_ConnectWithMothership, 'doRegisterRoutes']);
add_action('rest_api_init', [new \EmailTunnel\Action_SendCommandToMothership, 'doRegisterRoutes']);
add_action('rest_api_init', '\EmailTunnel\SonarPing::doRegisterRoute');

add_action("init", function () {
    //var_dump(SonarPing::doSonarPing());die();
});


require_once(plugin_dir_path(__FILE__) . 'src/plugin-update-checker-4.11/plugin-update-checker.php');
$myUpdateChecker = Puc_v4_Factory::buildUpdateChecker(
    'https://email-tunnel.com/wp-content/uploads/details.json',
    __FILE__, //Full path to the main plugin file or functions.php.
    'email-tunnel'
);

function activationHook()
{
}

register_activation_hook(__FILE__, function () {
    //ConnectionFinder::deleteAllConnections("etm-connection");
});

register_deactivation_hook(__FILE__, function () {
    //ConnectionFinder::deleteAllConnections("etm-connection");
});

add_action('wp', function () {
    if (!wp_next_scheduled('emailTunnel_daily_event')) {
        wp_schedule_event(time(), 'daily', 'emailTunnel_daily_event');
    }
});

add_action('emailTunnel_daily_event', function () {
    \EmailTunnel\SonarPing::doSonarPing();
});


//add_filter( 'heartbeat_settings', 'wp_heartbeat_settings_3242' );
function wp_heartbeat_settings_3242( $settings ) {
    $settings['interval'] = "fast"; //Anything between 15-120
    return $settings;
}
