<?php

namespace EmailTunnel;

abstract class Abstract_API_Action{



    /* This abstract class is used for opening up WordPress API routes, and mapping them to our
     * classes. For these actions greater than "exists", the user MUST be logged in, and submit a WordPress security nonce.
     * Note this is totally different from the "connection CPT nonces" we use in this plugin.
     */

    //public $capability = "activate_plugins";
    public $capability = "exists";

    public $nameSpace = "email-tunnel/v1";

    abstract public function doAction($args);

    private function getNamespace(){ return $this->nameSpace; }
    private function getCapability(){ return $this->capability; }
    private function getActionName(){return $this->actionName;}

    private function getHTTPmethods(){ return ['POST', 'GET']; }

    public function doRegisterRoutes(){
        \register_rest_route(
            $this->getNamespace(),
            $this->getActionName(),
            array(
                'methods' => ($this->getHTTPmethods()),
                'callback' => function () {
                    return ($this->doAction($_REQUEST));
                },
                'permission_callback' => function () {
                    $cap = $this->getCapability();
                    if (\current_user_can($cap)) {
                        return true;
                    }
                    return false;
                },
            )
        );
    }
}