<?php

namespace EmailTunnel;

class Connections{

    public static function getAdminEmails() {
        $args = array(
            'role' => 'administrator',
            'orderby' => 'user_nicename',
            'order' => 'ASC'
        );

        $admins = \get_users( $args );

        $emails = array();
        foreach ( $admins as $admin ) {
            $emails[] = $admin->user_email;
        }

        return $emails;
    }

    public static function doProcessSonarPingResult($args){
        $result = json_decode($args['body']);


        // $Connection = \EmailTunnel\GetPageByTitle::do( "THIS IS A VALIDATED REMOTE NODE", OBJECT, "etm-connection");
        $connectionID = $connectionID = ((ConnectionFinder::get_post_type_by_title("THIS IS A VALIDATED REMOTE NODE", "OBJECT", "etm-connection"))->ID);
        $licence = json_decode($args['body']);
        \update_post_meta($connectionID, "balls", "apple");
    }

    public static function register_API_Routes(){

        /*
        register_rest_route(
            "email-tunnel/v1",
            "get-site-status",
            array(
                'methods' => ['POST', 'GET'],
                'callback' => function () {
                    return Connections::getSiteStatus();
                },
                'permission_callback' => function () {
                    if (!(current_user_can("install_plugins"))) {
                        return FALSE;
                    }
                    return TRUE;
                },
                'validate_callback' => function(){return TRUE;}
            )
        );
        */
/*
        register_rest_route(
            "email-tunnel/v1",
            "set-site-status",
            array(
                'methods' => ['POST'],
                'callback' => function () {
                    return SiteStatus::setSiteStatus($_REQUEST['status']);
                },
                'permission_callback' => function () {
                    //return TRUE;
                    if (!(current_user_can("install_plugins"))) {
                        return FALSE;
                    }
                    return TRUE;
                },
                'validate_callback' => function () {
                    if(!isset($_REQUEST['status'])){
                        return FALSE;
                    }
                    return TRUE;
                }
            )
        );
*/
        register_rest_route(
            "email-tunnel/v1",
            "collapse-tunnel",
            array(
                'methods' => ['POST', 'GET'],
                'callback' => function () {
                    if($_REQUEST['status'] == "entrance"){
                        $Entrance = new TunnelEntrance;
                        $resp = $Entrance->removeEntranceCred($_REQUEST['siteUrl']);
                        $resp = $Entrance->getFilteredEntranceCredsForFrontEndUITableData();
                        return $resp;
                    }
                    if($_REQUEST['status'] == "exit"){

                        $userID = get_current_user_id();
                        //return "SERVER RESPONSE ALPHA" . $userID . $_REQUEST['siteUrl'];
                        $Exit = new TunnelExit;
                        $res = $Exit->removeExitCred($_REQUEST['siteUrl'], $userID);
                        $res = $Exit->getExitDataForFrontend($userID);
                        return $res;
                    }
                    return "SOMETHING IS WRONG";
                },
                'permission_callback' => function () {

                    //Remove this line to active nonce system:
                    //return TRUE;

                    if (!(current_user_can("install_plugins"))) {
                        return FALSE;
                    }
                    return TRUE;
                },
                'validate_callback' => function () {
                    if(!isset($_REQUEST['status'])){
                        return FALSE;
                    }
                    if(!isset($_REQUEST['siteUrl'])){
                        return FALSE;
                    }
                    return TRUE;
                }
            )
        );

    }

    public static function getSiteStatus() {
        // Fetch a validated remote node connection
        $validatedRemoteNode = ConnectionFinder::fetchValidatedNodeConnection();

        // Check if a validated remote node exists
        if ($validatedRemoteNode) {
            // Get the site status from the validated remote node
            $status = \get_post_meta($validatedRemoteNode->ID, "site-status", true);

            // Return "not connected" if status is not found
            if (!$status) {
                return "not connected";
            }
        } else {
            // Return "not connected" if no validated remote node exists
            return "not connected";
        }

        // Return the site status
        return $status;
    }

    public static function getRegisteredAdmin($returnType = "email"){

        switch ($returnType) {
            case "email":
                if(ConnectionFinder::get_post_type_by_title("THIS IS A VALIDATED REMOTE NODE", "OBJECT", "etm-connection") == null){
                    return false;
                }
                $userID = ((ConnectionFinder::get_post_type_by_title("THIS IS A VALIDATED REMOTE NODE", "OBJECT", "etm-connection"))->post_author);
                $user = get_user_by('id', $userID);
                return $user->user_email;
                break;
            case "user_id":
                if(ConnectionFinder::get_post_type_by_title("THIS IS A VALIDATED REMOTE NODE", "OBJECT", "etm-connection") == null){
                    return false;
                }
                return ((ConnectionFinder::get_post_type_by_title("THIS IS A VALIDATED REMOTE NODE", "OBJECT", "etm-connection"))->post_author);
                break;
        }

    }

}

