<?php

namespace EmailTunnel;

class ETMConnectionCPT
{

    public static function register_ETMConnectionCPT()
    {

        $labels = array(
            'name' => _x('Connections', 'etm-connection'),
            'singular_name' => _x('Connection', 'etm-connection'),
            'menu_name' => __('Connections', 'etm-connection'),
            'name_admin_bar' => __('Connections', 'etm-connection'),
            'archives' => __('Connection Archives', 'etm-connection'),
            'attributes' => __('Connection Attributes', 'etm-connection'),
            'parent_item_colon' => __('Parent Connection:', 'etm-connection'),
            'all_items' => __('All connections', 'etm-connection'),
            'add_new_item' => __('Add New Connection', 'etm-connection'),
            'add_new' => __('Add New', 'etm-connection'),
            'new_item' => __('New Connection', 'etm-connection'),
            'edit_item' => __('Edit Connection', 'etm-connection'),
            'update_item' => __('Update Connection', 'etm-connection'),
            'view_item' => __('View Connection', 'etm-connection'),
            'view_items' => __('View Connection', 'etm-connection'),
            'search_items' => __('Search Connection', 'etm-connection'),
            'not_found' => __('Not found', 'etm-connection'),
            'not_found_in_trash' => __('Not found in Trash', 'etm-connection'),
            'featured_image' => __('Featured Image', 'etm-connection'),
            'set_featured_image' => __('Set featured image', 'etm-connection'),
            'remove_featured_image' => __('Remove featured image', 'etm-connection'),
            'use_featured_image' => __('Use as featured image', 'etm-connection'),
            'insert_into_item' => __('Insert into Connection', 'etm-connection'),
            'uploaded_to_this_item' => __('Uploaded to this etm-connection', 'etm-connection'),
            'items_list' => __('Items list', 'etm-connection'),
            'items_list_navigation' => __('Items list navigation', 'etm-connection'),
            'filter_items_list' => __('Filter items list', 'etm-connection'),
        );
        $args = array(
            'label' => __('etm-connection', 'etm-connection'),
            'description' => __('A list of transactions', 'etm-connection'),
            'labels' => $labels,
            'supports' => array('title', 'author', 'editor', 'custom-fields', 'revisions'),
            'taxonomies' => array('category', 'post_tag'),
            'hierarchical' => false,
            /*
            'public'                => true,
            'show_ui'               => true,
            'show_in_menu'          => true,
            */
            'public' => false,
            'show_ui' => false,
            'show_in_menu' => false,
            'menu_position' => 5,
            'show_in_admin_bar' => true,
            'show_in_nav_menus' => true,
            'can_export' => true,
            'has_archive' => true,
            'exclude_from_search' => true,
            'publicly_queryable' => true,
            'capability_type' => 'post',
            'show_in_rest' => false,
        );
        register_post_type('etm-connection', $args);

    }
}