<?php

namespace EmailTunnel;

class MetadataIncrementer {

    public static function increment($post_id, $key) {
        // Retrieve the current count from post meta
        $data = \get_post_meta($post_id, $key, true);

        // Check if data exists and increment, otherwise set to 1
        if($data) {
            $data = $data + 1;
        } else {
            $data = 1;
        }

        // Update the post meta with the new count
        return \update_post_meta($post_id, $key, $data);
    }

    public static function get($post_id, $key) {
        // Retrieve the current count from post meta
        $data = \get_post_meta($post_id, $key, true);

        // Return the count if it exists, otherwise return 0
        if($data) {
            return $data;
        } else {
            return 0;
        }
    }

}
