<?php

namespace EmailTunnel;

class SettingsPage{

    public function render(){
        $adminEmail = Connections::getRegisteredAdmin();
        global $EmailTunnelConstants;
        $EmailTunnelDotComAdminEmail = $EmailTunnelConstants->emailTunnelDotComAdminEmail;
        $motherShipURL = $EmailTunnelConstants->motherShipURL;
        $currentUserEmail = \wp_get_current_user();
        $currentUserEmail = $currentUserEmail->user_email;


        //Internationalization and localization strings:
        $anEmailHasBeenSentStyle = "";
        $devScreen = "";
        $i18nAction = __("Action");
        $i18nAnEmail = __("Email sent to $currentUserEmail.<br/><br/>The email is coming from my personal email, johndeebdd@gmail.com, in case you want to contact me directly. I'm just a guy, not a company. Say, \"Hi!\".<br/><br/>Please click the link contained in the email to activate the plugin on this site.");
        $i18nAnErrorHasOccured = __("An unknown error has occurred.");
        $i18nClosed = __("Closed");
        $i18nConnect = __("Connect");
        $i18nConnectionCode = __("Connection Code");
        $i18nCreatedOnCreated = __("Created");
        $i18nEmails = __("Emails");
        $i18nEmailTunnel = __("Email Tunnel");
        $i18nEntrance = __("Entrance");
        $i18nEntranceSiteURL = __("Entrance Site URL");
        $i18nExit = __("Exit");
        $i18nExitSiteURL = __("Exit Site URL");
        $i18nGenerateCode = __("Generate Code");
        $i18nGetEmailTunnelPro = __("Get Email-Tunnel-Pro for unencrypted HTTP feature");
        $i18nGetEmailTunnelPro4Localhost = __("Get Email-Tunnel-Pro for localhost feature");
        $i18nInstallAndConnect = __("Install and connect the plugin on another WordPress site.");
        $i18nSomeSite = __("i.e. https://somesite.com");
        $i18nLocalStatus = __("Local Status");
        $i18nName = __("Name");
        $i18nPro = __("Pro");
        $i18nSite = __("Site");
        $i18nRemoteUsername = __("Remote User Name");
        $i18nSendConnectionEmailTo = __("Send Connection Email to");
        $i18nnbspSomeSite = __("  https://somesite.com");
        $i18nStatus = __("Status");
        $i18nThisSiteIsRegisteredToTheLocalAdmin = __("This site is registered to the local admin");
        $il18nSetTunnel = __("Set Tunnel");
        $i18nObtainOnOtherWebsite = __("obtain on other website");
        $i18nTheTunnelIsClosed = __("tunnel is closed.");
        $i18nThisSiteIsNotConnectedYet = __("Connect this site to your email-tunnel.com account.");
        $i18nYouAreNotConnected = __("You are not connected.");
        $i18nYouMustHaveSSL = __("You must have SSL enabled on both sites in the free version of this plugin. The URL should look like:");
        $requestConnectionEmailButtonStyle = "";

        if($adminEmail == false){
            $dbETPV = "NOT CONNECTED";
        }else{
            $dbETPV = License::get();
        }
        $statusStyle = "";
        switch ($dbETPV) {
            case "NOT CONNECTED":
                $i18nEmailTunnel = __("Email Tunnel");
                $i18nPro = "&nbsp;";
                $statusStyle = "#et-settings-page-usable-content-wrap{display:none;}";
                $anEmailHasBeenSentStyle = "#an-email-has-been-sent{display:none;}";
                $il8nHttpErrorMsg = "";
                break;
            case "PRO":
                $i18nEmailTunnel = __("Email Tunnel");
                $i18nPro = "PRO";
                $il8nHttpErrorMsg = __('Must start with "http://" or "https://" .');
                $statusStyle = "#free-version-pitch{display:none;} #not-connected-cta{display:none;}";
                $proVersion = ['pro'];
                wp_localize_script( 'email-tunnel-js', 'EmailTunnelProVersion', $proVersion );
                break;
            case "FREE":
                $i18nEmailTunnel = __("Email Tunnel");
                $il8nHttpErrorMsg = __('Must start with "https://" .');
                $i18nPro = "&nbsp;";
                $statusStyle = "#not-connected-cta{display:none;}";
                $proVersion = ['free'];
                wp_localize_script( 'email-tunnel-js', 'EmailTunnelProVersion', $proVersion );
                break;
        }

        //is there a pending email?
        $Connection = ConnectionFinder::get_post_type_by_title("ET MOTHERSHIP CONNECTION ATTEMPT", "OBJECT", "etm-connection");
        if($Connection != null){
            if(Action_ConnectWithMothership::isIt15MinutesOld($Connection->ID)){
                \wp_delete_post($Connection->ID, true);
            }
            //Re-fetch in case it was 15 minutes old
            $Connection = ConnectionFinder::get_post_type_by_title("ET MOTHERSHIP CONNECTION ATTEMPT", "OBJECT", "etm-connection");
            if(!($Connection === null)) {
                $requestConnectionEmailButtonStyle = "#request-connection-email-button{display:none;}";
                $anEmailHasBeenSentStyle = "#an-email-has-been-sent{display:display;}";
            }
        }


        $visitingAltAdminDivStyle = $this::returnVisitingAltAdminDivCSS($adminEmail, $currentUserEmail);
        $siteStatus = SiteStatus::getSiteStatus(ConnectionFinder::fetchValidatedNodeConnection());
        $siteStatus = __($siteStatus);

        $output = <<<OUTPUT
<style>
    $anEmailHasBeenSentStyle
    .email-tunnel-error-row{color:red;}
    .email-tunnel-error-row{display:none;}
    #email-tunnel-entrance-url-input-error-msg{display:none;}
    #email-tunnel-connection-table{display:none;}
    #closed-row{display:none;}
    #local-status-data-row{display:none;color:green;}
    #email-tunnel-entrance-button-spinner{float:left !important;}
    #exit-code-from-server{color:red;}
    #get-pro-pitch{display:none;}
    #orphaned-node-component{display:none;}
    #local-status-row{display:none;}
    #received-connection-code-row{display:none;}
    #you-are-not-connected-row{display:none;}
    #set-tunnel-row{display:none;}
    .spinner{display:none;}
    $requestConnectionEmailButtonStyle
    $statusStyle
    $visitingAltAdminDivStyle

</style>
<div class="wrap">
<h1>
   $i18nEmailTunnel $i18nPro 
</h1>

<div id = "not-connected-cta">
    <br />
    $i18nThisSiteIsNotConnectedYet<br />
    <br/>
    <button id = 'request-connection-email-button'>$i18nSendConnectionEmailTo $currentUserEmail</button><br />
    <div id = "an-email-has-been-sent">
        $i18nAnEmail
        <h2>John Dee</h2>
        <img src = "/wp-content/plugins/email-tunnel/src/img/john_dee.jpg" width = "400px" />
    </div><!-- end: an-email-has-been-send -->
</div><!-- end: #not-connected-cta -->

<div id = "et-settings-page-usable-content-wrap">

    <div id = "registered-to">
        $i18nThisSiteIsRegisteredToTheLocalAdmin, $adminEmail . 
    </div> <!-- end: #registered-to -->

    <div id = "free-version-pitch" class = "free-version">
        <br />
        Thank you for using the free version of email-tunnel. Enjoy!<br />
        <br />
        The pro version is only $9.99 a month.<br />
        <br />
        <a href = "$motherShipURL/product/pro/" target = "_blank"><button>Get Email Tunnel Pro</button></a><br />
        <br />
        Benefits of pro:<br />

        <ul>
            <li> - Send HTML emails. Free version is only text.</li>
            <li> - Connect unlimited sites. Free version is only two sites.</li>
            <li> - Connect local sites. Good for testing purposes.</li>
        </ul>
        <br />
    </div><!-- end: #free-version-pitch -->


    <div id = "orphaned-node-component">
        $i18nInstallAndConnect  
    </div>

    <div id = "unknown-error" class = "email-tunnel-error-row">
        $i18nAnErrorHasOccured
    </div><!-- end: #status-array-error -->
    </div><!-- end: #et-settings-page-usable-content-wrap -->
    
    <table class="form-table" role="presentation">
    <tr id = "local-status-row">
        
        <th>$i18nLocalStatus</th>
        <td id = "email-tunnel-local-status-td">$siteStatus</td>
    </tr>

    <tr id = "set-tunnel-row" >
        <th>Set Tunnel</th>
        <td>
        $i18nEntrance $i18nSite: <select id = "email-tunnel-add-entrance-site-url-select" name = "email-tunnel-add-entrance-site-url-select" /></select> 
        Exit Site: <select name = "email-tunnel-add-exit-site-url-select" id = "email-tunnel-add-exit-site-url-select" /></select>
        <input type = "submit" value = "Connect" id = "set-tunnel-connect-button" name = "set-tunnel-connect-button" />
        </td>
    </tr>
</table>

<table id="email-tunnel-connection-table" class="wp-list-table widefat fixed striped table-view-list">
    <thead>
        <tr>
            <th scope="col" class='manage-column column-primary'>$i18nEntrance</th>
            <th scope="col" class='manage-column'>$i18nExit</th>
            <th scope="col" id='action' class='manage-column'>$i18nAction</th>
        </tr>
    </thead>
    <tbody id="email-tunnel-connection-table-body">
    </tbody>
    <tfoot>
        <tr>
            <th scope="col" class='manage-column column-primary'>$i18nEntrance</th>
            <th scope="col" class='manage-column'>$i18nExit</th>
            <th scope="col" class='manage-column'>$i18nAction</th>
        </tr>
    </tfoot>
</table>
<br />
</div><!-- end: #visiting-alt-admin-div -->


</div><!-- end: wrap -->
OUTPUT;
        echo $output;
    }

    private static function returnVisitingAltAdminDivCSS($adminEmail, $currentUserEmail){
        $CSS = "";
        if($adminEmail == $currentUserEmail){
            $CSS = "#visiting-alt-admin-message-div{display:none'}";
        }else{
            $CSS = "#visiting-alt-admin-div{display:none;}";
        }
        return $CSS;
    }

}