import renderSettingsPage from './renderSettingsPage';

/*global jQuery*/
/*global EmailTunnelTunnelStatusArray*/

/**
 * Function to enable polling using WordPress Heartbeat API.
 * It listens for the 'heartbeat-tick' event and calls renderSettingsPage.
 *
 * @param {Array} EmailTunnelTunnelStatusArray - Array of email tunnel status.
 */
export default function enableHeartbeatPoll() {
    // Listen for the 'heartbeat-tick' event
     console.log("enableHeartbeatPoll");
    jQuery(document).on('heartbeat-tick', function () {
        console.log("heartbeat-tick line 16");
        // When the event is triggered, update the settings page
        doAjaxSiteStatus();
    });
}

function doAjaxSiteStatus(){
jQuery.ajax({

    url : '/wp-json/email-tunnel/v1/sonar-ping',
    type : 'GET',
    data : {
    },
    dataType:'json',
    success : function(data) {
        console.log("heartbeat-tick line 31");
        EmailTunnelTunnelStatusArray = JSON.parse(data);
        renderSettingsPage(EmailTunnelTunnelStatusArray);

    },
    error : function(request,error)
    {
        alert("Request: "+JSON.stringify(request));
    }
});


}