import enableHeartbeatPoll from './enableHeartbeatPoll';
import renderSettingsPage from './renderSettingsPage';
import $ from 'jquery';

jest.mock('./renderSettingsPage');

// Set jQuery globally for the test environment
global.jQuery = $;

describe('enableHeartbeatPoll', () => {
    let EmailTunnelTunnelStatusArray;

    beforeEach(() => {
        // Initialize the status array before each test
        EmailTunnelTunnelStatusArray = ['status1', 'status2'];
        // Clear all mock function calls before each test
        jest.clearAllMocks();
    });

    it('should update EmailTunnelTunnelStatusArray and call renderSettingsPage', () => {
        // Call the function to set up the event listener
        enableHeartbeatPoll(EmailTunnelTunnelStatusArray);

        // Simulate the 'heartbeat-tick' event
        jQuery(document).trigger('heartbeat-tick');

        // Verify that renderSettingsPage was called with the correct parameters
        expect(renderSettingsPage).toHaveBeenCalledWith(['status1', 'status2']);
    });
});
