import doCollapseTunnel from "./CollapseTunnelComponent";

export default function fillConnectionTableWithData(table, data) {
    const tableBody = table.querySelector('tbody');
    tableBody.innerHTML = ''; // Clear existing rows if any

    // Filter for 'entrance' entries
    const entranceData = data.filter(item => item.status === "entrance");

    if (entranceData.length === 0) {
        const row = document.createElement('tr');
        const cell = document.createElement('td');
        cell.textContent = "No sites connected.";
        cell.colSpan = 3; // Assuming there are four columns: Entrance, Exit, Emails, Action
        row.appendChild(cell);
        tableBody.appendChild(row);
    } else {
        entranceData.forEach(item => {
            const row = document.createElement('tr');

            const titleCell = document.createElement('td');
            titleCell.textContent = item.title;
            row.appendChild(titleCell);

            const exitSiteCell = document.createElement('td');
            exitSiteCell.textContent = item['exit-site'];
            row.appendChild(exitSiteCell);

           // const emailCountCell = document.createElement('td');
           // emailCountCell.textContent = item['email-count'];
           // row.appendChild(emailCountCell);

            const actionCell = document.createElement('td');
            // Updated to include a button that calls the doCollapseTunnel function
            const button = document.createElement('button');
            button.textContent = 'Collapse Tunnel';
            button.onclick = () => doCollapseTunnel(item.title, item['exit-site']);
            actionCell.appendChild(button);
            row.appendChild(actionCell);

            tableBody.appendChild(row);
        });
    }
}
