import returnNetworkURLsFromStatusDataArray from './returnNetworkURLsFromStatusDataArray.js';
import setupConnectButtonComponent from "./setupConnectButtonComponent";
import fillConnectionTableWithData from "./fillConnectionTableWithData";


//This is the main "render" file for the Email Tunnel plugin settings page.
//The render function can  be called at any time, and it updates the screen and the dom via jQuery
//The renderSettingsPage function gets it's data from the global variable
/*global wpApiSettings*/

export default function renderSettingsPage(statusData){

    console.log("renderSettingsPage(statusData)");
    console.log("Status Data:")
    console.log(statusData);
    //componets:
    if(!validateStatusData(statusData)){
        jQuery("#unknown-error").show();
    }else{
        jQuery("#unknown-error").hide();
    }
    if(statusData['status-array'].length == 1){
        console.log("orphaned node detected");
        jQuery("#orphaned-node-component").show();
        jQuery("#local-status-row").hide();
        jQuery("#set-tunnel-row").hide();
        jQuery("#email-tunnel-connection-table").hide();
       // console.log("tryin...");
       // jQuery("#email-tunnel-local-status-td").html("not connected");
        return;
    }
    
    jQuery("#orphaned-node-component").hide();
    jQuery("#local-status-row").show();
    jQuery("#set-tunnel-row").show();
    jQuery("#email-tunnel-connection-table").show();
    doFillSelectOptions("email-tunnel-add-entrance-site-url-select", returnNetworkURLsFromStatusDataArray(statusData));
    doFillSelectOptions("email-tunnel-add-exit-site-url-select", returnNetworkURLsFromStatusDataArray(statusData));

    //setupConnectButtonComponent();

    //const table = document.getElementById('email-tunnel-connection-table');
    fillConnectionTableWithData(document.getElementById('email-tunnel-connection-table'), EmailTunnelTunnelStatusArray['status-array']);

    getSiteStatus(statusData['status-array']);
}
function validateStatusData(statusData){
    return true;
}
function renderOrphanedNodeComponent(statusData){
    //This function checks the number of items in statusData['status-array'] and shows the orphaned node component if there is only one item in the array
    console.log("renderOrphanedNodeComponent()");
}

function doFillConnectionsTable(statusData){
    //This function fills the connections table with data from statusData
    console.log("doFillConnectionsTable()");

}

function doFillSelectOptions(selectID, optionsArray) {
    // Clear existing options
    jQuery('#' + selectID).empty();

    // Append each item from the optionsArray as both value and text of the options
    optionsArray.forEach(function(option) {
        jQuery('#' + selectID).append(jQuery('<option>', {
            value: option,
            text: option
        }));
    });
}


function getSiteStatus(statusArray){
    const apiRoot = wpApiSettings.root;
    const siteURL = apiRoot.replace('/wp-json/', '');

    console.log("getting site statuszz...");
    let siteStatus = "";
    statusArray.forEach((item) => {

        if (item['title'] == siteURL) {
            if (item['status'] === "entrance") {
                // If the local site's URL matches the 'title' and its status is 'entrance',
                // set the local site as an entrance and specify its corresponding exit site.
                siteStatus = "entrance";
                console.log("a" + siteStatus);
                return siteStatus;
            }
        }
        if (item['status'] === "entrance" && item['exit-site'] === siteURL) {
            // If the local site's URL matches the 'exit-site' of an entrance site,
            // set the local site as the exit for that entrance.
            siteStatus = "exit";
            console.log("b" + siteStatus);
            return siteStatus;
        }
    });
    return "not connected";

}