import renderSettingsPage from "./renderSettingsPage";
import setUIinteractiveState from "./setUIinteractiveState";
import AjaxSiteStatus from "./AjaxSiteStatus";

export default function setupConnectButtonComponent() {
    const button = document.querySelector("#set-tunnel-connect-button");
    button.addEventListener("click", function() {
        let entranceSiteURL = jQuery("#email-tunnel-add-entrance-site-url-select").val();
        let exitSiteURL = jQuery("#email-tunnel-add-exit-site-url-select").val();
        if (!(validateSubmission(entranceSiteURL, exitSiteURL))) {
            console.error("Validation failed: The entrance and exit URLs must be different.");
            return;
        } else {
            console.log("Validation succeeded: URLs are different.");
        }
        setUIinteractiveState("disable");
        doAjaxServer(entranceSiteURL, exitSiteURL);
    });
}

function validateSubmission(entranceSiteURL, exitSiteURL){
    if (entranceSiteURL === exitSiteURL) {
        alert("Entrance and Exit sites must be different.");
        return false; // The URLs are the same, which is invalid
    } else {
        return true; // The URLs are different, which is valid
    }
}

function doAjaxServer(entranceSiteURL, exitSiteURL) {
    console.log("setupConnectButton::doAjaxServer");
    jQuery.ajax({
        url: "/wp-json/email-tunnel/v1/send-command-2-ms",
        type: 'POST',
        data: {
            '_wpnonce': wpApiSettings.nonce,
            'exit-site-url': exitSiteURL,
            'entrance-site-url': entranceSiteURL,
            'command': "add-tunnel",
        },
        dataType: 'json',  // This expects the response to be in JSON format
        success: function(response) {
            let data = response['body'];

            //console.log("Raw data:", data); // Log raw data for verification

            if (typeof data === 'string') {
                // Parse the first level of JSON string
                data = JSON.parse(data);
              //  console.log("First parse (should still be a string):", data);

                // Now parse the second level if it's still a string
                if (typeof data === 'string') {
                    data = JSON.parse(data);
                //    console.log("Second parse (should now be an object):", data);
                }
            }
            EmailTunnelTunnelStatusArray['status-array'] = data;
            console.log(EmailTunnelTunnelStatusArray);
            renderSettingsPage(EmailTunnelTunnelStatusArray);
            setUIinteractiveState("enable");
            AjaxSiteStatus();
        },
        error: function(error) {
            console.error('AJAX error:', error);
        }
    });
}
