<?php

namespace EmailTunnel;

class SiteStatus{


    public static function setSiteStatus($status, $validatedETMConnectionID)
    {
        \update_post_meta($validatedETMConnectionID, "site-status", $status);
        if ($status === "exit" or $status === "not connected") {
            \delete_post_meta($validatedETMConnectionID, "site-exit");
        }
        return true;
    }

    public static function getSiteStatus($validatedETMConnection)
    {
        // Check if a validated remote node exists
        if ($validatedETMConnection) {
            // Get the site status from the validated remote node
            $status = \get_post_meta($validatedETMConnection->ID, "site-status", true);

            // Return "not connected" if status is not found
            if (!$status) {
                return "not connected";
            }
        } else {
            // Return "not connected" if no validated remote node exists
            return "not connected";
        }

        // Return the site status
        return $status;
    }

    public static function setSiteExit($exitSiteURL)
    {
        $ValidatedRemoteNode = ConnectionFinder::fetchValidatedNodeConnection();
        \update_post_meta($ValidatedRemoteNode->ID, "site-exit", $exitSiteURL);
        return true;
    }
}