<?php

namespace EmailTunnel;

class SonarPing{


    public static function doSonarPing()
    {

        $etmConnection = ConnectionFinder::get_post_type_by_title("THIS IS A VALIDATED REMOTE NODE", "OBJECT", "etm-connection");
        if (!$etmConnection) {
            return false;
        }
        $blogInfo = [];
        foreach (['name', 'description', 'wpurl', 'url', 'admin_email', 'charset', 'version', 'html_type', 'language'] as $f) {
            $blogInfo[$f] = \get_bloginfo($f);
        }
        $blogInfo['number-of-emails'] = MetadataIncrementer::get($etmConnection->ID, 'number_of_emails');
        $blogInfo['adminEmails'] = Connections::getAdminEmails();
        $blogInfo['etm-user-nonce'] = \get_post_meta($etmConnection->ID, "etm-nonce", true);
        global $EmailTunnelConstants;
        $Url = $EmailTunnelConstants->motherShipURL . $EmailTunnelConstants->pingEndpoint;
        $result = \wp_remote_post(
            $Url,
            [
                'method' => 'POST',
                'blocking' => true,
                'body' =>
                    [
                        'blogInfo' => $blogInfo,
                    ],
                'sslverify' => false,
            ]
        );
        if(is_wp_error($result)){
            echo("error.");
            echo("URL: " ); vardump($Url);
            var_dump($result);
            die();
        }
        if ((str_replace('"', "", $result['body']) == "ERROR: NO CONNECTION FOUND")) {
            \wp_delete_post($etmConnection->ID, true);
            die("Unable to connect. Please try again later. [ERROR: SonarPing.class.php #45]");
        }
        self::validateSonarPingResultOrDie($result);
        global $post;
        $args = [];
        $result['body'] = json_decode($result['body'], true);
        $licence = $result['body'];
        $args['post_content'] = $licence['license'];
        $args['post_type'] = "etm-connection";
        $args['post_status'] = 'draft';
        $args['ID'] = $etmConnection->ID;
        \wp_update_post($args);
        \update_post_meta($etmConnection->ID, "licence", $licence['license']);
        $statusArray = $result['body'];
        $statusArray = $statusArray['status-array'];
        SetLocalStatusFromStatusArray::doSetStatus($statusArray);
        return self::doFormatResult($result);
    }

    private static function doFormatResult($result){
        $http_response = $result['http_response'];
        // Use Reflection to access the protected 'response' property
        $reflection = new \ReflectionClass($http_response);
        $property = $reflection->getProperty('response');
        $property->setAccessible(true);
        $response = $property->getValue($http_response);
        // Check if the body property exists within response
        if (isset($response->body)) {
            $body = $response->body;
        } else {
            echo 'Body property does not exist within response';
        }
        return $body;
}


    public static function validateSonarPingResultOrDie($result)
    {
        if ($result['response']['code'] == 200) {
            return;
        }

        // Collect detailed error information
        $responseCode = isset($result['response']['code']) ? $result['response']['code'] : 'No code';
        $responseMessage = isset($result['response']['message']) ? $result['response']['message'] : 'No message';
        $responseBody = isset($result['body']) ? $result['body'] : 'No body';

        // Log the detailed error information (assuming there's a log function available)
        error_log("Sonar Ping Failed - Code: $responseCode, Message: $responseMessage, Body: $responseBody");

        // Output detailed error information
        die("Unable to connect to network. Please try again later. [ERROR: Connections.class.php #115]
         Code: $responseCode
         Message: $responseMessage
         Body: $responseBody");
    }

    public static function doRegisterRoute(){
        \register_rest_route(
            "email-tunnel/v1",
            "sonar-ping",
            array(
                'methods' => ['get', 'post'],
                'callback' => function () {
                    return SonarPing::doSonarPing();;
                },
                'permission_callback' => function () {
                    return true;
                },
                'validate_callback' => function ($args) {
                }
            )
        );
    }
}
