<?php

namespace EmailTunnel;

class TunnelEntrance{

    public function interceptOutgoingEmail($to, $subject, $message, $headers = '', $attachments = array()){
        $etmConnectionPost = ConnectionFinder::fetchValidatedNodeConnection();
        if (!$etmConnectionPost) {
            error_log('Failed to fetch a validated node connection');
            return false;
        }

        $etmConnectionPostID = $etmConnectionPost->ID;
        $siteExit = \get_post_meta($etmConnectionPostID, "site-exit", true);
        $fields = [
            'to' => $to,
            'subject' => $subject,
            'message' => $message,
            'headers' => $headers,
            'etm-user-nonce' => UserNonce::getSiteAdminUserNonce(),
        ];

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $siteExit . "/wp-json/email-tunnel/v1/tunnel-exit/");
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        $data = [];
        foreach ($fields as $key => $value) {
            $data[$key] = $value;
        }

        // Attach files if present
        foreach ($attachments as $index => $file) {
            if (file_exists($file)) {
                $data['attachments[' . $index . ']'] = new CURLFile($file);
            }
        }

        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        $result = curl_exec($ch);
        curl_close($ch);

        return $result;
    }


} 
