<?php

namespace EmailTunnel;

class TunnelExit{
    
    public function openTunnelExit(){
        \add_action ('rest_api_init', [$this, 'doOpenExitAPI']);
    }

    public function doOpenExitAPI(){
        register_rest_route(
            "email-tunnel/v1",
            "tunnel-exit",
            array(
                'methods' => ['POST', 'GET'],
                'callback' => function () {
                    return new \WP_REST_Response(
                        [
                            'status' => 200,
                            'response' => "OK",
                            'body_response' => ($this->doSendMail()),
                        ]
                    );
                },
                'permission_callback' => function ($args) {
                    if($args['etm-user-nonce'] === UserNonce::getSiteAdminUserNonce()){
                        return true;
                    }else{
                        return false;
                    }
                },
                'validate_callback' => function () {
                    return true;
                }
            )
        );
    }

    public function doSendMail() {
        $to = $_REQUEST['to'];
        $subject = $_REQUEST['subject'];
        $message = $_REQUEST['message'];
        $headers = $_REQUEST['headers'] ?? "";
        $attachments = $_FILES['attachments'] ?? []; // Adjust based on actual structure

        $license = License::get();
        if ($license != "PRO") {
            // Drop attachments if not PRO
            $attachments = [];
            $message = strip_tags($message);
            $headers = $this->makeEmailHeadersPlainTextOnly($headers);
        }

        \wp_mail($to, $subject, $message, $headers, $attachments);
        return "email sent";
    }

    public function makeEmailHeadersPlainTextOnly($headers) {
        $search = 'Content-type:text/html;';
        $replacement = 'Content-Type: text/plain;';
        $modifiedHeaders = str_replace($search, $replacement, $headers);

        return $modifiedHeaders;
    }

    public function doProcessForLicense($headers, $message){

        return $headers;
    }

}